' CharSetOfHTML.VBS V1.00 (C) yoshioka.teruo@nifty.com 2006-06-12
' CharSetOfHTML.VBS shows charset specification of HTML files.
' Usage: Start CharSetOfHTML.VBS files...

Option Explicit
Dim fso
Dim re
Dim arg
Dim CharSet
Dim StdIn
Dim Line
Dim Matches

If WScript.Arguments.Count=0 Then
  WScript.Echo "Usage: Start CharSetOfHTML.VBS files..."
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")

Set re=New RegExp
re.Pattern="<\s*meta\s+[^>]*\bcharset\s*=\s*([-A-Za-z0-9_]+)[^>]*>"
re.IgnoreCase=True

For Each arg In WScript.Arguments
  CharSet="(None)"
  Set StdIn=OpenTextFile(fso,arg)
  If Not StdIn.AtEndOfStream Then
    Line=StdIn.Read(2048)
    Set Matches=re.Execute(Line)
    If Matches.Count Then
      CharSet=Matches.Item(0).Value
    End If
  End If
  StdIn.Close
  WScript.Echo arg & vbLf & CharSet
Next
WScript.Quit

Function OpenTextFile(fso,Path)
Dim BOM
Dim fUNICODE
BOM=fso.OpenTextFile(Path).Read(2)
fUNICODE=BOM=Chr(&HFF)&Chr(&HFE) Or BOM=Chr(&HFE)&Chr(&HFF)
Set OpenTextFile=fso.OpenTextFile(Path,,,fUNICODE)
End Function
